# CTFd Openstack Integration

This is a WIP to provide per-challenge, per-user openstack deployments within CTFd in which each deployment is given a unique seed.

An example use case is a challenge that requires a user to ssh into a box and read a file to get the flag. This module would provide inputs into an openstack HEAT yaml and then return the outputs to the user prompt. In this case, the output is the openstack floating IP and the ssh port. The student could then ssh into the box and find a unique flag for that specific build instance.

## Development Roadmap 

The plugin will need to do the following:

Implement a new challenge type "openstack challenge" (see: https://github.com/CTFd/CTFd/wiki/Plugins#challenge-types )
 * Every new deployment will have a random seed that produces a random flag output

Implement a new flag type "openstack flag" (see: )
 * valid flags of this type correspond to an active deployment of an openstack challenge

Database scheme:

New tables:

openstack_challenge:
-id
-source url
-location on disk
-point value
-category
-etc

openstack_deployment
-id
-challenge_id
-user_id
-deployment_time
-teardown_time
-inputs
-outputs
-seed
-flag
-active

openstack_flag
-id
-challenge_id
-deployment_id


## Design Considerations

Where do we store creds?

How are yamls fed into the framework?
- For example, flat files uploaded?
- git url to pull from? 
- git url to pull from on every deployment (ensure most up to date?)

Probably best to pull from a git url on first deployment. Ideally it should pull down a directory and then deploy a filename. This allows for embedded yamls that reference other yamls, as necessary.
