// Markdown Preview

function upload_lane_files(form, cb) {
    if (form instanceof jQuery) {
        form = form[0];
    }
    var formData = new FormData(form);
    console.log(formData)
    upload_filename = form.elements["file"].files[0].name
    formData.append('nonce', csrf_nonce);
    if ( upload_filename.slice(-4) == ".zip" ) {
      formData.append("start_file", prompt("You are uploading a zip. Please enter the filename of the top-level yaml to be loaded for this lane.","")); 
    } else if ( upload_filename.slice(-4) != ".yml" && upload_filename.slice(-5) != ".yaml") {
      alert ("Unsupported filetype.");
      return false;
    } else {
      formData.append('start_file', upload_filename)
    }
    $.ajax({
        url: script_root + '/admin/upload_lane',
        data: formData,
        dataType: "json",
        type: 'POST',
        cache: false,
        contentType: false,
        processData: false,
        success: function (data) {
            if (cb) {
                cb(data);
            }
        }
    });
}

function handle_lane_upload(data) {
  for(i=0; i<data.length; i++)
  {
    $("ul.openstack-lanes-viewer").prepend(build_list_item_from_lane(data[i]))
  }
  $("#lane_upload_form").trigger("reset")
}

function preview_lane(id) {
  $.get("/admin/get_lane/"+id, function(data) {
    $("#lane_contents").empty().html(data)
  });
}

function delete_lane(id) {
  if(confirm("delete lane "+id+"?")) {
   $.getJSON("/admin/delete_lane/"+id, function(data) {
    $("#lane_"+data).parent().remove()
   });
  }
}

function build_list_item_from_lane(lane) {
  li = $("<li></li>")
  lane_html = "<span id='lane_"+lane.id+"'> Name: "+lane.lane_name + lane.id+ "</span> [<a href='javascript:delete_lane("+lane.id+")'>X</a>]"
  li.html(lane_html)
  li.find("span").each(
    function( index ) {
      $(this).css("cursor","pointer") 
      $(this).click(function() {
        cur_id = $(this).attr("id").replace("lane_","")
        preview_lane(cur_id)
      });
    }
  );
  return li
}

document.addEventListener("DOMContentLoaded", function(event) { 
	$.get("/plugins/openstack_integration/assets/upload_lanes.html", function(data) { 
		$("#upload_lanes_container").html(data);
		$("#lane_upload_form").submit(function(event) {
			event.preventDefault();
      upload_lane_files(this,handle_lane_upload)
		});
    $.getJSON("/admin/get_lanes", function(data) {
      lanes = data
      ul = $("<ul class='openstack-lanes-viewer'></ul>")
      for (i=0; i<lanes.length; i++) {
        ul.append(build_list_item_from_lane(lanes[i]))
      }
      $("#lane_list").append(ul);
    });
	});


});


/*
$('#desc-edit').on('shown.bs.tab', function (event) {
    if (event.target.hash == '#desc-preview'){
        var editor_value = $('#desc-editor').val();
        $(event.target.hash).html(
            window.challenge.render(editor_value)
        );
    }
});
$('#new-desc-edit').on('shown.bs.tab', function (event) {
    if (event.target.hash == '#new-desc-preview'){
        var editor_value = $('#new-desc-editor').val();
        $(event.target.hash).html(
            window.challenge.render(editor_value)
        );
    }
});
$("#solve-attempts-checkbox").change(function() {
    if(this.checked) {
        $('#solve-attempts-input').show();
    } else {
        $('#solve-attempts-input').hide();
        $('#max_attempts').val('');
    }
});

$(document).ready(function(){
    $('[data-toggle="tooltip"]').tooltip();
});
*/
